Index: trunk/zoo-project/zoo-kernel/service_conf.y
===================================================================
--- trunk/zoo-project/zoo-kernel/service_conf.y	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_conf.y	(revision 640)
@@ -174,4 +174,5 @@
       current_element->defaults=NULL;
       current_element->supported=NULL;
+      current_element->child=NULL;
       current_element->next=NULL;
     }
@@ -223,4 +224,5 @@
 	current_element->defaults=NULL;
 	current_element->supported=NULL;
+	current_element->child=NULL;
 	current_element->next=NULL;
       }
Index: trunk/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal.c	(revision 640)
@@ -23,10 +23,6 @@
  */
 
+#include "fcgi_stdio.h"
 #include "service_internal.h"
-#ifdef USE_MS
-#include "service_internal_ms.h"
-#else
-#include "cpl_vsi.h"
-#endif
 
 #ifndef TRUE
@@ -37,86 +33,5 @@
 #endif
 
-#ifndef WIN32
-#include <dlfcn.h>
-#endif
-
 #define ERROR_MSG_MAX_LENGTH 1024
-
-#include "mimetypes.h"
-
-/**
- * Verify if a given language is listed in the lang list defined in the [main] 
- * section of the main.cfg file.
- * 
- * @param conf the map containing the settings from the main.cfg file
- * @param str the specific language
- * @return 1 if the specific language is listed, -1 in other case.
- */
-int isValidLang(maps* conf,const char *str){
-  map *tmpMap=getMapFromMaps(conf,"main","lang");
-  char *tmp=zStrdup(tmpMap->value);
-  char *pToken=strtok(tmp,",");
-  int res=-1;
-  while(pToken!=NULL){
-    if(strcasecmp(str,pToken)==0){
-      res=1;
-      break;
-    }
-    pToken = strtok(NULL,",");
-  }
-  free(tmp);
-  return res;
-}
-
-/**
- * Print the HTTP headers based on a map.
- * 
- * @param m the map containing the headers informations
- */
-void printHeaders(maps* m){
-  maps *_tmp=getMaps(m,"headers");
-  if(_tmp!=NULL){
-    map* _tmp1=_tmp->content;
-    while(_tmp1!=NULL){
-      printf("%s: %s\r\n",_tmp1->name,_tmp1->value);
-      _tmp1=_tmp1->next;
-    }
-  }
-}
-
-/**
- * Add a land attribute to a XML node
- *
- * @param n the XML node to add the attribute
- * @param m the map containing the language key to add as xml:lang
- */
-void addLangAttr(xmlNodePtr n,maps *m){
-  map *tmpLmap=getMapFromMaps(m,"main","language");
-  if(tmpLmap!=NULL)
-    xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST tmpLmap->value);
-  else
-    xmlNewProp(n,BAD_CAST "xml:lang",BAD_CAST "en-US");
-}
-
-/**
- * Converts a hex character to its integer value 
- *
- * @param ch the char to convert
- * @return the converted char 
- */
-char from_hex(char ch) {
-  return isdigit(ch) ? ch - '0' : tolower(ch) - 'a' + 10;
-}
-
-/**
- * Converts an integer value to its hec character 
- *
- * @param code the char to convert
- * @return the converted char 
- */
-char to_hex(char code) {
-  static char hex[] = "0123456789abcdef";
-  return hex[code & 15];
-}
 
 /**
Index: trunk/zoo-project/zoo-kernel/service_internal.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal.c	(revision 640)
@@ -4111,131 +634,2 @@
 }
 
-/**
- * Verify if a parameter value is valid.
- * 
- * @param request the request map
- * @param res the error map potentially generated
- * @param toCheck the parameter to use
- * @param avalues the acceptable values (or null if testing only for presence)
- * @param mandatory verify the presence of the parameter if mandatory > 0 
- */
-void checkValidValue(map* request,map** res,const char* toCheck,const char** avalues,int mandatory){
-  map* lres=*res;
-  map* r_inputs = getMap (request,toCheck);
-  if (r_inputs == NULL){
-    if(mandatory>0){
-      char *replace=_("Mandatory parameter <%s> was not specified");
-      char *message=(char*)malloc((strlen(replace)+strlen(toCheck)+1)*sizeof(char));
-      sprintf(message,replace,toCheck);
-      if(lres==NULL){
-	lres=createMap("code","MissingParameterValue");
-	addToMap(lres,"text",message);
-	addToMap(lres,"locator",toCheck);       
-      }else{
-	int length=1;
-	map* len=getMap(lres,"length");
-	if(len!=NULL){
-	  length=atoi(len->value);
-	}
-	setMapArray(lres,"text",length,message);
-	setMapArray(lres,"locator",length,toCheck);
-	setMapArray(lres,"code",length,"MissingParameter");
-      }
-      free(message);
-    }
-  }else{
-    if(avalues==NULL)
-      return;
-    int nb=0;
-    int hasValidValue=-1;
-    while(avalues[nb]!=NULL){
-      if(strcasecmp(avalues[nb],r_inputs->value)==0){
-	hasValidValue=1;
-	break;
-      }
-      nb++;
-    }
-    if(hasValidValue<0){
-      char *replace=_("The value <%s> was not recognized, %s %s the only acceptable value.");
-      nb=0;
-      char *vvalues=NULL;
-      char* num=_("is");
-      while(avalues[nb]!=NULL){
-	char *tvalues;
-	if(vvalues==NULL){
-	  vvalues=(char*)malloc((strlen(avalues[nb])+3)*sizeof(char));
-	  sprintf(vvalues,"%s",avalues[nb]);
-	}
-	else{
-	  tvalues=zStrdup(vvalues);
-	  vvalues=(char*)realloc(vvalues,(strlen(tvalues)+strlen(avalues[nb])+3)*sizeof(char));
-	  sprintf(vvalues,"%s, %s",tvalues,avalues[nb]);
-	  free(tvalues);
-	  num=_("are");
-	}
-	nb++;
-      }
-      char *message=(char*)malloc((strlen(replace)+strlen(num)+strlen(vvalues)+strlen(toCheck)+1)*sizeof(char));
-      sprintf(message,replace,toCheck,vvalues,num);
-      if(lres==NULL){
-	lres=createMap("code","InvalidParameterValue");
-	addToMap(lres,"text",message);
-	addToMap(lres,"locator",toCheck);       
-      }else{
-	int length=1;
-	map* len=getMap(lres,"length");
-	if(len!=NULL){
-	  length=atoi(len->value);
-	}
-	setMapArray(lres,"text",length,message);
-	setMapArray(lres,"locator",length,toCheck);
-	setMapArray(lres,"code",length,"InvalidParameterValue");
-      }
-    }
-  }
-  if(lres!=NULL){
-    *res=lres;
-  }
-}
-
-/**
- * Access the last error message returned by the OS when trying to dynamically
- * load a shared library.
- *
- * @return the last error message
- * @warning The character string returned from getLastErrorMessage resides
- * in a static buffer. The application should not write to this
- * buffer or attempt to free() it.
- */ 
-char* getLastErrorMessage() {                                              
-#ifdef WIN32
-  LPVOID lpMsgBuf;
-  DWORD errCode = GetLastError();
-  static char msg[ERROR_MSG_MAX_LENGTH];
-  size_t i;
-  
-  DWORD length = FormatMessage(
-			       FORMAT_MESSAGE_ALLOCATE_BUFFER | 
-			       FORMAT_MESSAGE_FROM_SYSTEM |
-			       FORMAT_MESSAGE_IGNORE_INSERTS,
-			       NULL,
-			       errCode,
-			       MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
-			       (LPTSTR) &lpMsgBuf,
-			       0, NULL );	
-  
-#ifdef UNICODE		
-  wcstombs_s( &i, msg, ERROR_MSG_MAX_LENGTH,
-	      (wchar_t*) lpMsgBuf, _TRUNCATE );
-#else
-  strcpy_s( msg, ERROR_MSG_MAX_LENGTH,
-	    (char *) lpMsgBuf );		
-#endif	
-  LocalFree(lpMsgBuf);
-  
-  return msg;
-#else
-  return dlerror();
-#endif
-}
-
Index: trunk/zoo-project/zoo-kernel/service_internal.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal.h	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal.h	(revision 640)
@@ -74,84 +74,32 @@
 #include <time.h>
 #include <ctype.h>
-#ifdef WIN32
 #ifndef USE_RUBY
 #include <unistd.h>
-#endif
 #endif
 #ifndef WIN32
 #include <xlocale.h>
 #endif
-#include "ulinet.h"
 
 #include "service.h"
-#include <openssl/sha.h>
-#include <openssl/md5.h>
-#include <openssl/hmac.h>
-#include <openssl/evp.h>
-#include <openssl/bio.h>
-#include <openssl/buffer.h>
 
-extern   int conf_read(const char*,maps*);
+#if defined(macintosh) || (defined(__MACH__) && defined(__APPLE__))
 
-#ifdef USE_JS
-#ifdef WIN32
-#define XP_WIN 1
-#else
-#define XP_UNIX 0
+#include <CoreServices/CoreServices.h>
+#include <SystemConfiguration/SystemConfiguration.h>
+
 #endif
-#include "service_internal_js.h"
-#endif
-
 
 #ifdef __cplusplus
 extern "C" {
 #endif
-#include <libxml/parser.h>
-#include <libxml/xpath.h>
 
-  /**
-   * Maximum number of XML namespaces
-   */
-#define ZOO_NS_MAX 10
-  /**
-   * Maximum number of XML docs
-   */
-#define ZOO_DOC_MAX 20
+  int  setOutputValue( maps*, const char*, char*, size_t);
+  char* getInputValue( maps*,const char*,size_t*);
 
-  /**
-   * Global char* to store the serverAddress value of the mmmmmain section
-   */
-  static char* SERVICE_URL;
-  /**
-   * Array of xmlNsPtr storing all used XML namespace
-   */
-  static xmlNsPtr usedNs[ZOO_NS_MAX];
-  /**
-   * Array storing names of the used XML namespace
-   */
-  static char* nsName[ZOO_NS_MAX];
-  /**
-   * Number of XML namespaces
-   */
-  static int nbNs=0;
-  /**
-   * Array of xmlDocPtr storing XML docs
-   */
-  static xmlDocPtr iDocs[ZOO_DOC_MAX];
-  /**
-   * Number of XML docs
-   */
-  static int nbDocs=0;
-
-  int getServiceFromYAML(maps*,char*,service**,char *name);
-  int readServiceFile(maps*, char*,service**,char *);
-  int isValidLang(maps*,const char*);
-  void addLangAttr(xmlNodePtr,maps*);
-
-  void printHeaders(maps*);
   void unhandleStatus(maps*);
   int _updateStatus(maps*);
   char* _getStatus(maps*,int);
   char* getStatus(int);
+  int updateStatus( maps*,const int,const char*);
   int removeShmLock(maps*, int);
   /**
@@ -170,62 +118,4 @@
 #endif
   
-  void readGeneratedFile(maps*,map*,char*);
-
-  void URLDecode(char *);
-  char *url_encode(char *);
-  char *url_decode(char *);
-  char* getEncoding(maps*);
-
-  int zooXmlSearchForNs(const char*);
-  int zooXmlAddNs(xmlNodePtr,const char*,const char*);
-  void zooXmlCleanupNs();
-
-  int zooXmlAddDoc(xmlNodePtr,const char*,const char*);
-  void zooXmlCleanupDocs();
-  
-  void printExceptionReportResponse(maps*,map*);
-  xmlNodePtr createExceptionReportNode(maps*,map*,int);
-  void printProcessResponse(maps*,map*,int,service*,const char*,int,maps*,maps*);
-  xmlNodePtr printWPSHeader(xmlDocPtr,maps*,const char*,const char*);
-  xmlNodePtr printGetCapabilitiesHeader(xmlDocPtr,maps*);
-  void printGetCapabilitiesForProcess(maps*,xmlNodePtr,service*);
-  void printDescribeProcessForProcess(maps*,xmlNodePtr,service*);
-  void printFullDescription(int,elements*,const char*,xmlNsPtr,xmlNodePtr);
-  void printDocument(maps*,xmlDocPtr,int);
-  void printDescription(xmlNodePtr,xmlNsPtr,const char*,map*);
-  void printIOType(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,xmlNsPtr,elements*,maps*,const char*);
-  map* parseBoundingBox(const char*);
-  void printBoundingBox(xmlNsPtr,xmlNodePtr,map*);
-  void printBoundingBoxDocument(maps*,maps*,FILE*);
-  void printOutputDefinitions(xmlDocPtr,xmlNodePtr,xmlNsPtr,xmlNsPtr,elements*,maps*,const char*);
-
-  void outputResponse(service*,maps*,maps*,map*,int,maps*,int);
-
-  void dumpMapsValuesToFiles(maps**,maps**);
-
-  char *base64(const char*,int);
-  char *base64d(const char*,int,int*);
-  void ensureDecodedBase64(maps**);
-  void checkValidValue(map*,map**,const char*,const char**,int);
-  char* addDefaultValues(maps**,elements*,maps*,int,map**);
-
-  int errorException(maps *, const char *, const char *, const char*);
-
-  xmlNodePtr soapEnvelope(maps*,xmlNodePtr);
-  int checkForSoapEnvelope(xmlDocPtr);
-  
-  void addToCache(maps*,char*,char*,char*,int,char*,size_t);
-  char* isInCache(maps*,char*);
-  int runHttpRequests(maps**,maps**,HINTERNET*);
-  void addRequestToQueue(maps**,HINTERNET*,const char*,bool);
-  int loadRemoteFile(maps**,map**,HINTERNET*,char*);
-
-  char *readVSIFile(maps*,const char*);
-  void parseIdentifier(maps*,char*,char*,char*);
-  int updateStatus( maps*,const int,const char*);
-  char* getInputValue( maps*,const char*,size_t*);
-  int  setOutputValue( maps*, const char*, char*, size_t);
-  
-  char* getLastErrorMessage();
 #ifdef __cplusplus
 }
Index: trunk/zoo-project/zoo-kernel/service_internal_java.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_java.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal_java.c	(revision 640)
@@ -24,4 +24,5 @@
 
 #include "service_internal_java.h"
+#include "response_print.h"
 
 /**
@@ -87,10 +88,10 @@
   int nb=1;
   int nbc0=0;
-  maps* javaXXMap=getMaps(main_conf,"javaxx");
+  maps* javaXXMap=getMaps(*main_conf,"javaxx");
   if(javaXXMap!=NULL){
     nbc0+=count(javaXXMap->content);
   }
   int nbc1=0;
-  maps* javaXMap=getMaps(main_conf,"javax");
+  maps* javaXMap=getMaps(*main_conf,"javax");
   if(javaXMap!=NULL){
     nbc1+=count(javaXMap->content);
@@ -107,6 +108,4 @@
   long result;
   jmethodID pmid;
-  jfieldID fid;
-  jobject jobj;
   jclass cls;
 #ifdef JAVA7
@@ -502,7 +501,6 @@
    * }
    */
-  jclass scHashMap_class,scSetClass,scIteratorClass,scMapEntryClass,scSet_class,scMapClass;
+  jclass scSetClass,scIteratorClass,scMapEntryClass;
   jmethodID entrySet_mid,containsKey_mid,get_mid,iterator_mid,hasNext_mid,next_mid,getKey_mid,getValue_mid;
-  jobject scObject,scObject1;
   if(scHashMapClass==NULL){
 #ifdef DEBUG
Index: trunk/zoo-project/zoo-kernel/service_internal_js.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_js.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal_js.c	(revision 640)
@@ -23,5 +23,6 @@
  */
 
-#include "service_internal.h"
+#include "service_internal_js.h"
+#include "response_print.h"
 
 #ifndef JSCLASS_GLOBAL_FLAGS
@@ -67,6 +68,4 @@
 JSLoadScripts(JSContext *cx, uintN argc, jsval *argv1)
 {
-  //map* request = JS_GetContextPrivate(cx);
-  //map* tmpm1=getMap(request,"metapath");
   JS_MaybeGC(cx);
 
@@ -78,5 +77,4 @@
   JS_MaybeGC(cx);
   for(i=0;i<argc;i++){
-    JSString* jsmsg = JS_ValueToString(cx,argv[i]);
     char *filename = JSValToChar(cx,&argv[i]);
     char *api0=(char*)malloc((strlen(ntmp)+strlen(filename)+2)*sizeof(char));
@@ -110,7 +108,7 @@
 int zoo_js_support(maps** main_conf,map* request,service* s,maps **inputs,maps **outputs)
 {
-  maps* main=*main_conf;
+  /*maps* main=*main_conf;
   maps* _inputs=*inputs;
-  maps* _outputs=*outputs;
+  maps* _outputs=*outputs;*/
 
   /* The class of the global object. */
@@ -202,7 +200,7 @@
   /* Your application code here. This may include JSAPI calls
      to create your own custom JS objects and run scripts. */
-  maps* out=*outputs;
+  //maps* out=*outputs;
   int res=SERVICE_FAILED;
-  maps* mc=*main_conf;
+  //maps* mc=*main_conf;
   map* tmpm2=getMap(s->content,"serviceProvider");
 
@@ -216,5 +214,5 @@
   stat(filename, &file_status);
   //char *source=(char*)malloc(file_status.st_size);
-  uint16 lineno;
+  //uint16 lineno;
   jsval rval;
   JSBool ok ;
@@ -281,5 +279,5 @@
   }
 
-  jsval t=OBJECT_TO_JSVAL(d);
+  //jsval t=OBJECT_TO_JSVAL(d);
   if(JS_IsArrayObject(cx,d)){
 #ifdef JS_DEBUG
@@ -395,5 +393,4 @@
   if(s==0){
     jsval rval;
-    JSBool ok ;
     JSObject *script = JS_CompileFile(cx, JS_GetGlobalObject(cx), filename);
     if(script!=NULL){
@@ -425,11 +422,8 @@
 JSObject* JSObject_FromMaps(JSContext *cx,maps* t){
   JSObject* res=JS_NewObject(cx, NULL, NULL, NULL);
-  //JSObject *res = JS_NewArrayObject(cx, 0, NULL);
   if(res==NULL)
     fprintf(stderr,"Array Object is NULL!\n");
   maps* tmp=t;
   while(tmp!=NULL){
-    jsuint len;
-    JSObject* res1=JS_NewObject(cx, NULL, NULL, NULL);
     JSObject *pval=JSObject_FromMap(cx,tmp->content);
     jsval pvalj=OBJECT_TO_JSVAL(pval);
@@ -452,5 +446,4 @@
 JSObject* JSObject_FromMap(JSContext *cx,map* t){
   JSObject* res=JS_NewObject(cx, NULL, NULL, NULL);
-  jsval resf =  OBJECT_TO_JSVAL(res);
   map* tmpm=t;
   map* isArray=getMap(t,"isArray");
@@ -463,7 +456,7 @@
     fprintf(stderr,"tmap is not null ! (%s = %s)\n",tmap->name,tmap->value);
 #endif
-  while(tmpm!=NULL){
+  while(isArray==NULL && tmpm!=NULL){
     jsval jsstr;
-    if((isArray==NULL && isBinary!=NULL && strncasecmp(tmpm->name,"value",5)==0))
+    if((isBinary!=NULL && strncasecmp(tmpm->name,"value",5)==0))
       jsstr = STRING_TO_JSVAL(JS_NewStringCopyN(cx,tmpm->value,atoi(isBinary->value)));
     else
@@ -534,7 +527,6 @@
 	jsval id = idp->vector[index];
 	jsval vp;
-	JSString* str; 
 	JS_IdToValue(cx,id,&vp);
-	char *c, *tmp;
+	char *tmp;
 	JSString *jsmsg;
 	size_t len1;
@@ -583,5 +575,5 @@
   fprintf(stderr,"outputs array length : %d\n",len);
 #endif
-  for(oi=0;oi < len;oi++){
+  for(oi=0;hasLen && oi < len;oi++){
 #ifdef JS_DEBUG
     fprintf(stderr,"outputs array length : %d step %d \n",len,oi);
@@ -605,7 +597,6 @@
 	jsval id = idp->vector[index];
 	jsval vp;
-	JSString* str; 
 	JS_IdToValue(cx,id,&vp);
-	char *c, *tmp;
+	char *tmp;
 	JSString *jsmsg;
 	size_t len1;
@@ -706,7 +697,6 @@
       jsval id = idp->vector[index];
       jsval vp;
-      JSString* str; 
       JS_IdToValue(cx,id,&vp);
-      char *c, *tmp, *tmp1;
+      char *tmp, *tmp1;
       JSString *jsmsg,*jsmsg1;
       size_t len,len1;
@@ -877,6 +867,4 @@
   jsval *argv = JS_ARGV(cx,argv1);
   HINTERNET hInternet;
-  HINTERNET res;
-  HINTERNET res1;
   JSObject *header;
   char *url;
@@ -884,5 +872,4 @@
   char* tmpValue;
   size_t dwRead;
-  int i=0;
   JS_MaybeGC(cx);
   hInternet=InternetOpen("ZooWPSClient\0",
Index: trunk/zoo-project/zoo-kernel/service_internal_ms.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_ms.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal_ms.c	(revision 640)
@@ -32,4 +32,6 @@
 #endif
 #include "service_internal_ms.h"
+#include "server_internal.h"
+#include "response_print.h"
 
 /**
Index: trunk/zoo-project/zoo-kernel/service_internal_otb.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_otb.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal_otb.c	(revision 640)
@@ -28,6 +28,13 @@
 
 #include "service_internal_otb.h"
+#include "response_print.h"
+#include "server_internal.h"
 
 using namespace otb::Wrapper;
+
+/**
+ * Global OTB counter 
+ */
+int otbCounter=0;
 
 /**
@@ -148,5 +155,5 @@
 	  for (unsigned int i = 0; i < appKeyList.size(); i++){
 	    const std::string paramKey(appKeyList[i]);
-	    std::vector<std::string> values;
+	    fprintf(stderr,"%s %d %s !\n",__FILE__,__LINE__,paramKey.c_str());
 	    Parameter::Pointer param = m_Application->GetParameterByKey(paramKey);
 	    ParameterType type = m_Application->GetParameterType(paramKey);
@@ -154,4 +161,5 @@
 	      map* test=getMapFromMaps(inputs,paramKey.c_str(),"cache_file");
 	      if(test==NULL){
+		fprintf(stderr,"%s %d %s \n",__FILE__,__LINE__,paramKey.c_str());
 		test=getMapFromMaps(inputs,paramKey.c_str(),"inRequest");
 		map* tmpPath=getMapFromMaps(m,"main","tmpPath");
@@ -160,5 +168,5 @@
 		map* tmpVal=getMapFromMaps(outputs,paramKey.c_str(),"mimeType");
 		maps* tmpMaps=getMaps(outputs,paramKey.c_str());
-		if(test!=NULL && test->value!=NULL && strncasecmp(test->value,"true",4)==0){
+		if(tmpMaps!=NULL && test!=NULL && test->value!=NULL && strncasecmp(test->value,"true",4)==0){
 		  test=getMapFromMaps(inputs,paramKey.c_str(),"value");
 		  if(type == ParameterType_OutputImage){
@@ -187,12 +195,9 @@
 			    ext="jpeg";
 		    }
-		    sprintf(tmp,"%s/%s_%s.%s",tmpPath->value,s->name,tmpSid->value,ext);
+		    sprintf(tmp,"%s/%s_%d_%s.%s",tmpPath->value,s->name,otbCounter,tmpSid->value,ext);
+		    otbCounter++;
 		    m_Application->SetParameterString(paramKey, tmp);
 		    setMapInMaps(inputs,paramKey.c_str(),"generated_file",tmp);
 		    dynamic_cast<OutputImageParameter *> (param.GetPointer())->SetPixelType(outPixType);
-		  }
-		  else{ 
-		    if(test!=NULL && test->value!=NULL)
-		      m_Application->SetParameterString(paramKey, test->value);
 		  }
 		}else{
@@ -212,5 +217,6 @@
 			      ext="kml";
 		      }
-		      sprintf(tmp,"%s/%s_%s.%s",tmpPath->value,s->name,tmpSid->value,ext);
+		      sprintf(tmp,"%s/%s_%d_%s.%s",tmpPath->value,s->name,otbCounter,tmpSid->value,ext);
+		      otbCounter++;
 		      m_Application->SetParameterString(paramKey, tmp);
 		      setMapInMaps(inputs,paramKey.c_str(),"generated_file",tmp);
@@ -234,5 +240,5 @@
 				if(strncasecmp(tmpVal->value,"application/vnd.google-earth.kmz",32)==0){
 				  ext="kmz";
-				  sprintf(tmp,"%s/%s_%sxt.%s",tmpPath->value,s->name,tmpSid->value,ext);
+				  sprintf(tmp,"%s/%s_%d_%sxt.%s",tmpPath->value,s->name,otbCounter,tmpSid->value,ext);
 				  m_Application->SetParameterString(paramKey, tmp);
 				  setMapInMaps(outputs,paramKey.c_str(),"expected_generated_file",tmp);
@@ -240,12 +246,37 @@
 
 		      }
-		      sprintf(tmp,"%s/%s_%s.%s",tmpPath->value,s->name,tmpSid->value,ext);
+		      sprintf(tmp,"%s/%s_%d_%s.%s",tmpPath->value,s->name,otbCounter,tmpSid->value,ext);
+		      otbCounter++;
 		      m_Application->SetParameterString(paramKey, tmp);
 		      setMapInMaps(inputs,paramKey.c_str(),"generated_file",tmp);
 		    }
-
+		    else{
+		      test=getMapFromMaps(inputs,paramKey.c_str(),"value");
+		      if(test!=NULL && type!=ParameterType_ListView){
+			m_Application->SetParameterString(paramKey, test->value);
+		      }
+		      else
+			if(type==ParameterType_ListView){
+			  std::vector<std::string> values;
+			  values.push_back(test->value);
+			  map* tmpLength=getMapFromMaps(inputs,paramKey.c_str(),"length");
+			  if(tmpLength!=NULL){
+			    int len=atoi(tmpLength->value);
+			    for(int k=1;k<len;k++){
+			      char tmp[15];
+			      sprintf(tmp,"cache_file_%d",k);
+			      map* tmpVal=getMapFromMaps(inputs,paramKey.c_str(),tmp);
+			      if(tmpVal!=NULL){
+				values.push_back(tmpVal->value);
+			      }
+			    }
+			  }
+			  dynamic_cast<ListViewParameter *> (param.GetPointer())->SetSelectedItems(values);
+			}
+		    }
 		}
 	      }else{
 		if(type == ParameterType_InputImageList){
+		  std::vector<std::string> values;
 		  values.push_back(test->value);
 		  map* tmpPath=getMapFromMaps(inputs,paramKey.c_str(),"length");
Index: trunk/zoo-project/zoo-kernel/service_internal_otb.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_otb.h	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal_otb.h	(revision 640)
@@ -31,8 +31,8 @@
 #include "otbWrapperApplicationRegistry.h"
 #include "otbWrapperInputImageListParameter.h"
+#include "otbWrapperListViewParameter.h"
 #include "otbWrapperAddProcessToWatchEvent.h"
 #include "otbZooWatcher.h"
 #include "service_internal.h"
-#include "mimetypes.h"
 #include "service.h"
 #include "cgic.h"
Index: trunk/zoo-project/zoo-kernel/service_internal_python.h
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_python.h	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal_python.h	(revision 640)
@@ -29,4 +29,5 @@
 
 #include "service_internal.h"
+#include "response_print.h"
 #include <Python.h>
 #include "cgic.h"
Index: trunk/zoo-project/zoo-kernel/service_internal_saga.c
===================================================================
--- trunk/zoo-project/zoo-kernel/service_internal_saga.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/service_internal_saga.c	(revision 640)
@@ -33,4 +33,5 @@
 #define _ZOO_SAGA
 #include "service_internal_saga.h"
+#include "server_internal.h"
 #include "mimetypes.h"
 
Index: trunk/zoo-project/zoo-kernel/zcfg2yaml.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zcfg2yaml.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/zcfg2yaml.c	(revision 640)
@@ -23,5 +23,6 @@
  */
 
-#include "service_internal.h"
+#include "server_internal.h"
+#include "response_print.h"
 #include "service.h"
 
Index: trunk/zoo-project/zoo-kernel/zoo_loader.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zoo_loader.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/zoo_loader.c	(revision 640)
@@ -37,4 +37,5 @@
 #include <unistd.h>
 #include "service_internal.h"
+#include "response_print.h"
 
 
@@ -216,5 +217,4 @@
    * one.
    */
-
   if(strncasecmp(cgiRequestMethod,"post",4)==0 || 
      (count(tmpMap)==1 && strncmp(tmpMap->value,"<",1)==0) 
@@ -287,8 +287,22 @@
 	xmlXPathObjectPtr versptr=extractFromDoc(doc,"/*/*/*[local-name()='Version']");
 	xmlNodeSet* vers=versptr->nodesetval;
-	xmlChar* content=xmlNodeListGetString(doc, vers->nodeTab[0]->xmlChildrenNode,1);
-	addToMap(tmpMap,"version",(char*)content);
+	if(vers!=NULL && vers->nodeTab!=NULL && vers->nodeTab[0]!=NULL){
+	  xmlChar* content=xmlNodeListGetString(doc, vers->nodeTab[0]->xmlChildrenNode,1);
+	  addToMap(tmpMap,"version",(char*)content);
+	  xmlFree(content);
+	}
+	if(cur->ns){
+	  addToMap(tmpMap,"wps_schemas",(char*)cur->ns->href);
+	  xmlFree(tval);
+	  int j=0;
+	  for(j=0;j<2;j++)
+	    if(strncasecmp(schemas[j][2],(char*)cur->ns->href,strlen(schemas[j][2]))==0){
+	      char vers[6];
+	      sprintf(vers,"%d.0.0",j+1);
+	      addToMap(tmpMap,"version",(char*)vers);
+	    }
+	}
+	dumpMap(tmpMap);
 	xmlXPathFreeObject(versptr);
-	xmlFree(content);
       }else{
 	tval=NULL;
@@ -376,4 +390,5 @@
     free(strQuery);
 
+  
   runRequest(&tmpMap);
 
Index: trunk/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 639)
+++ trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 640)
@@ -54,5 +54,8 @@
 
 #include "service_internal.h"
+#include "server_internal.h"
+#include "response_print.h"
 #include "request_parser.h"
+#include "sqlapi.h"
 
 #ifdef USE_PYTHON
@@ -1044,4 +1047,6 @@
   r_inputs = getMap (request_inputs, "language");
   if (r_inputs == NULL)
+    r_inputs = getMap (request_inputs, "AcceptLanguages");
+  if (r_inputs == NULL)
     r_inputs = getMapFromMaps (m, "main", "language");
   if (r_inputs != NULL)
@@ -1141,5 +1146,5 @@
     NULL
   };
-  checkValidValue(request_inputs,&err,"Request",(const char**)vvr,1);
+  checkValidValue(request_inputs,&err,"request",(const char**)vvr,1);
   const char *vvs[]={
     "WPS",
@@ -1161,6 +1166,8 @@
   }
   checkValidValue(request_inputs,&err,"service",(const char**)vvs,1);
+
   const char *vvv[]={
     "1.0.0",
+    "2.0.0",
     NULL
   };
@@ -1172,5 +1179,16 @@
   }else{
     checkValidValue(request_inputs,&err,"AcceptVersions",(const char**)vvv,-1);
+    map* version=getMap(request_inputs,"AcceptVersions");
+    if(version!=NULL){
+      if(strstr(version->value,schemas[1][0])!=NULL)
+	addToMap(request_inputs,"version",schemas[1][0]);
+      else
+	addToMap(request_inputs,"version",version->value);
+    }
   }
+  map* version=getMap(request_inputs,"version");
+  if(version==NULL)
+    version=getMapFromMaps(m,"main","version");
+  setMapInMaps(m,"main","rversion",version->value);
   if(err!=NULL){
     printExceptionReportResponse (m, err);
@@ -1237,5 +1255,6 @@
       r_inputs = NULL;
       //r_inputs = getMap (request_inputs, "ServiceProvider");
-      xmlNodePtr n=printGetCapabilitiesHeader(doc,m);
+      r_inputs = getMap (request_inputs, "version");
+      xmlNodePtr n=printGetCapabilitiesHeader(doc,m,(r_inputs!=NULL?r_inputs->value:"1.0.0"));
       /**
        * Here we need to close stdout to ensure that unsupported chars 
@@ -1299,6 +1318,9 @@
           xmlDocPtr doc = xmlNewDoc (BAD_CAST "1.0");
           r_inputs = NULL;
+	  r_inputs = getMap (request_inputs, "version");
+	  map* version=getMapFromMaps(m,"main","rversion");
+	  int vid=getVersionId(version->value);
 	  xmlNodePtr n = printWPSHeader(doc,m,"DescribeProcess",
-					"ProcessDescriptions");
+					root_nodes[vid][1],(r_inputs!=NULL?r_inputs->value:"1.0.0"),1);
 
           r_inputs = getMap (request_inputs, "Identifier");
@@ -1748,4 +1770,5 @@
    *  - usid : it is an unique identification number 
    *  - sid : it is the process idenfitication number (OS)
+   *  - uusid : it is an universally unique identification number 
    *  - status : value between 0 and 100 to express the  completude of 
    * the operations of the running service 
@@ -1777,4 +1800,7 @@
   sprintf (tmpBuff, "%i", cpid);
   addToMap (_tmpMaps->content, "sid", tmpBuff);
+  char* tmpUuid=get_uuid();
+  addToMap (_tmpMaps->content, "uusid", tmpUuid);
+  free(tmpUuid);
   addToMap (_tmpMaps->content, "status", "0");
   addToMap (_tmpMaps->content, "cwd", ntmp);
